#!/usr/bin/python
# -*- coding:UTF-8 -*-

'''
-- blackpredator.py
-- v1.15
-- By Messiah93
-- http://messiah93.com
'''

import es
import gamethread
import playerlib
import repeat
import usermsg
import spe
import random
import popuplib
import unicodedata

import psyco
psyco.full()

info = es.AddonInfo()
info.name = "[FR] BlackPredator"
info.version = "v1.14"
info.author = "Messiah93"
info.url = "http://messiah93.com/"

VITESSE_T = es.ServerVar("blackpredator_predspeed", 1.55)
HEALTH_ADDCT_T = es.ServerVar("blackpredator_predaddcthealth", 125)
HEALTH_T_DEF = es.ServerVar("blackpredator_preddefhealth", 150)
GRAVITY_T = es.ServerVar("blackpredator_predgravity", 0.45)
TRANSPARENCE_T = es.ServerVar("blackpredator_predinvisibility", 10)
NOCTURNE_GIVE_T    = es.ServerVar("blackpredator_predgivenocturne", 1)
CASH_CT    = es.ServerVar("blackpredator_ctcash", 5500)
PRED_KILLBONUS = es.ServerVar("blackpredator_predkillbonus", 1)
PRED_BONUSVIE = es.ServerVar("blackpredator_predhpbonus", 75)
SCREENBLOOD = es.ServerVar("blackpredator_ctbloodscreen", 1)
SPEEDCUTCT = es.ServerVar("blackpredator_ctspeedcut", 1)
SPEEDCUTCT_TIME = es.ServerVar("blackpredator_ctspeedcuttime", 3)
PRED_FREEZETIME = es.ServerVar("blackpredator_predfreetime", 3)
FLASHVIEW = es.ServerVar("blackpredator_predflashvisibility", 1)
AMBIANTSOUND1 = es.ServerVar("blackpredator_soundambiant1", "blackpredator/ambiant1.mp3")
AMBIANTSOUNDTIME = es.ServerVar("blackpredator_ambiantsoundtime", 90)
PREDWINSOUND1 = es.ServerVar("blackpredator_soundpredwin1", "blackpredator/predwin1.mp3")
CTDEATH1 = es.ServerVar("blackpredator_soundctdeath1", "blackpredator/ctdeath1.mp3")
CTDEATH2 = es.ServerVar("blackpredator_soundctdeath2", "blackpredator/ctdeath2.mp3")
CTDEATH3 = es.ServerVar("blackpredator_soundctdeath3", "blackpredator/ctdeath3.mp3")
PREDDEATH1 = es.ServerVar("blackpredator_soundpreddeath1", "blackpredator/preddeath1.mp3")
SKYBOXNAME = es.ServerVar("blackpredator_skyboxname", "boreal")
MAPLIGHTSTYLE_STRING = es.ServerVar("blackpredator_maplightstylestring", 0)
MAPLIGHTSTYLE_INDEX = es.ServerVar("blackpredator_maplightstyleindex", "b")
CANUSETERRORISTWEAPONS = es.ServerVar("blackpredator_useterroristweapons", 1)
PREDATORCHOICERANDOM = es.ServerVar("blackpredator_predrandom", 0)
PRED_REMOVEHUD = es.ServerVar("blackpredator_removehud", 1)
HIDE_CUT_AND_HAND = es.ServerVar("blackpredator_removecutandhand", 0)
SCREENOVERLAY_PRED = es.ServerVar("blackpredator_pred_overlay", "0")
ROLLANGE = es.ServerVar("blackpredator_rollangle", 3)
PRED_FALLDAMAGE = es.ServerVar("blackpredator_predator_falldamage", 0)
MINDXLEVEL = es.ServerVar("blackpredator_mindxlevel", 90)
REMOVESUN = es.ServerVar("blackpredator_removemapsun", 1)

TerrorWeaponList = {"elite":800, "mac10":1400, "galil":2000, "ak47":2500, "g3sg1":5000}
EntityRemoveList = ["hostage_entity", "func_bomb_target", "func_hostage_rescue"]
StripedItems = ["knife", "nvgs"]
SoonPredSwitch = 0.25

BPCVarList = {}
CTHavePredSpeed    = []
StartedPlayersAmbiantSound = []
DommagesOnPredByCT = {}
DommagesOnPred = 0
ScriptBuyTime = 0
PredIsFlashed = False
AllowTerrorWeaponBuy = False
StopPredOverlay = False
PoweredPredNightVision = False

predatorUserID = int()

def load ():
    Script.execConfig()
    es.regcmd("bp_addcvar", "blackpredator/addCVarBlackPredator")
    es.ServerVar("messiah93_blackpredator", info["version"]).makepublic()
    es.regcmd("kill", "blackpredator/passCreatedCommand")
    es.regcmd("explode", "blackpredator/passCreatedCommand")
    if int(CANUSETERRORISTWEAPONS): 
        es.regsaycmd("!buy", "blackpredator/buyTerroristWeapons")
        es.regclientcmd("!buy", "blackpredator/buyTerroristWeapons")
    es.addons.registerClientCommandFilter(parseclientcmd)
    goDownload()
    createMenuWeaponsTerr()

    if str(es.server_var["sv_pure"]) != "0":
        es.forcevalue("sv_pure", 0)
        es.dbmsg(0, "[ES::BlackPredator] ERREUR: SV_PURE EST A 1 OU 2 - LES SKINS NE SONT PAS CHARGES!")
    if str(es.server_var["sv_consistency"]) != "0":
        es.forcevalue("sv_consistency", "0")
        Script.echo("ERREUR: SV_CONSISTENCY EST A 1 - LES SKINS NE SONT PAS CHARGES!")

    if not int(PRED_FALLDAMAGE):
        spe.registerPreHook("player_falldamage", pre_player_falldamage)

    for userid in es.getUseridList():
        disableAutokick(str(userid))

    repeat.create("blackpredator_showhp", showPredatorHP)
    repeat.create("blackpredator_predoverlay", setPredatorOverlay)
    if int(MINDXLEVEL):
        repeat.create("blackpredator_checkdxlevel", allCheckDXLevel)

    repeat.start("blackpredator_showhp", 1, 0)
    repeat.start("blackpredator_predoverlay", 1, 0)
    if int(MINDXLEVEL):
        repeat.start("blackpredator_checkdxlevel", 5, 0)
    Script.msg("Script chargé.")
    Script.log("Loaded.")

def unload ():
    for i in StartedPlayersAmbiantSound:
        stopAmbiantSound(i)
    deleteMenuWeaponsTerr()
    es.addons.unregisterClientCommandFilter(parseclientcmd)
    if int(CANUSETERRORISTWEAPONS):
        es.unregsaycmd("!buy")
        es.unregclientcmd("!buy")
    if not int(PRED_FALLDAMAGE):
        spe.unregisterPreHook("player_falldamage", pre_player_falldamage)
    repeat.stop("blackpredator_showhp")
    repeat.stop("blackpredator_predoverlay")
    if int(MINDXLEVEL):
        repeat.stop("blackpredator_checkdxlevel")
    
    repeat.delete("blackpredator_showhp")
    repeat.delete("blackpredator_predoverlay")
    if int(MINDXLEVEL):
        repeat.delete("blackpredator_checkdxlevel")
    Script.msg("Script stoppé.")
    Script.log("Unloaded.")

class Script (object):
    def __init__ (self):
        self.selfModule = __import__(__name__)
        
        self.info = es.AddonInfo()
        self.info.name = "BlackPredator"
        self.info.version = "v1.15"
        self.info.author = "Messiah93"
        self.info.url = "http://messiah93.com"
        
        self.messiah93 = es.ServerVar("messiah93_%s" % self._getNormalizedString(self.info.name).lower().replace(" ", "_"))
        self.messiah93.set(self.info.version)
        self.messiah93.makepublic()
        
        self.configFile = "../addons/eventscripts/blackpredator/blackpredator_config.cfg"
    
    def execConfig (self):
        es.mexec(self.configFile)
    
    def printScriptInfos (self, userid):
        gamethread.delayed(5.00, self.tell, (userid, "\x07FF3D3D%s créé par \x079ACDFFMessiah93." % self.info.version))
    
    def msg (self, arg):
        es.msg("[" + self.info.name + "] %s" % arg)
    
    def tell (self, userid, arg):
        es.tell(userid, "[" + self.info.name + "] %s" % arg)
    
    def log (self, arg):
        try: 
            name = self._getNormalizedString(self.info.name)
        except: 
            name = self.info.name
        
        try:
            arg = self._getNormalizedString(arg)
        except:
            pass
        
        es.log("[ES::" + name + "] %s" % arg)
    
    def echo (self, arg):
        try: 
            name = self._getNormalizedString(self.info.name)
        except: 
            name = self.info.name
        
        try:
            arg = self._getNormalizedString(arg)
        except:
            pass
        
        es.dbgmsg(0, "[ES::" + name + "] %s" % arg)
    
    def _getNormalizedString (self, arg):
        try:
            arg = arg.decode("utf-8")
        except:
            try:
                arg = unicode(arg, "raw-unicode-escape")
            except:
                pass
        
        try:
            normalizedString = unicodedata.normalize("NFKD", arg)
            normalizedString = normalizedString.encode("ASCII", "ignore")
        except: 
            normalizedString = arg
        
        return normalizedString

Script = Script()

def pre_player_falldamage (event_var):
    if int(es.getplayerteam(event_var["userid"])) == 2:
        es.setplayerprop(event_var["userid"], "CBasePlayer.m_iHealth", es.getplayerprop(event_var["userid"], "CBasePlayer.m_iHealth") + int(event_var["damage"]))

def setPredatorOverlay ():
    if str(SCREENOVERLAY_PRED) != "0":
        if not StopPredOverlay:
            if predatorUserID:
                es.server.insertcmd("es_xcexec %s r_screenoverlay %s" % (predatorUserID, str(SCREENOVERLAY_PRED)))
        else:
            if predatorUserID:
                es.server.insertcmd("es_xcexec %s r_screenoverlay 0" % predatorUserID)
    else:
        if predatorUserID:
            es.server.insertcmd("es_xcexec %s r_screenoverlay 0" % predatorUserID)

def canBuyWeaponsOfTerrorists (type):
    global AllowTerrorWeaponBuy

    if type == "yes":
        AllowTerrorWeaponBuy = True
    elif type == "no":
        AllowTerrorWeaponBuy = False

def passCreatedCommand ():
    pass

def addCVarBlackPredator ():
    global BPCVarList
    
    Command = es.getargv(1)
    Value = es.getargv(2)
    BPCVarList[Command] = Value

def buyTerroristWeapons ():
    userid = es.getcmduserid()
    plid = playerlib.getPlayer(userid)
    if int(es.getplayerteam(userid)) == 3:
        if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
            if AllowTerrorWeaponBuy:
                if plid.get("inbuyzone"):
                    argument = es.getargv(1)
                    if str(argument) in TerrorWeaponList:
                        verifyCashAndBuyWeapon(userid, TerrorWeaponList[str(argument)], str(argument), str(argument))
                    else:
                        popuplib.send("blackpredator_terroweaponsmenu", userid) 
                else:
                    es.centertell (userid, "Vous n'êtes pas dans une zone d'achat.")
            else:
                es.centertell (userid, "%i secondes se sont écoulées...\nVous ne pouvez plus rien acheter !" % ScriptBuyTime)

def createMenuWeaponsTerr ():
    weapTerr = popuplib.create("blackpredator_terroweaponsmenu")
    weapTerr.addline("-- Black Predator Mod --")
    weapTerr.addline("---------------------------")
    weapTerr.addline("> Armes terroristes :")
    weapTerr.addline("---------------------------")
    weapTerr.addline("->1. Dual-elites [$800]")
    weapTerr.addline("->2. Mac10 [$1400]")
    weapTerr.addline("->3. Galil [$2000]")
    weapTerr.addline("->4. AK-47 [$2500]")
    weapTerr.addline("->5. G3SG1 [$5000]")
    weapTerr.addline("---------------------------")
    weapTerr.addline("->0. Annuler")
    weapTerr.menuselect = menuTerrWeaponSelect

def menuTerrWeaponSelect (userid, choix, popup):
    if int(choix) == 1:
        verifyCashAndBuyWeapon(userid, 800, "Dual Elites", "elite")
    elif int(choix) == 2:
        verifyCashAndBuyWeapon(userid, 1400, "Mac10", "mac10")
    elif int(choix) == 3:
        verifyCashAndBuyWeapon(userid, 2000, "Galil", "galil")
    elif int(choix) == 4:
        verifyCashAndBuyWeapon(userid, 2500, "AK-47", "ak47")
    elif int(choix) == 5:
        verifyCashAndBuyWeapon(userid, 5000, "G3SG1", "g3sg1")

def deleteMenuWeaponsTerr ():
    popuplib.delete("blackpredator_terroweaponsmenu")

def verifyCashAndBuyWeapon (userid, cash, weapon, realweapon):
    plid = playerlib.getPlayer(userid)
    if int(es.getplayerteam(userid)) == 3:
        if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
            if AllowTerrorWeaponBuy:
                if plid.get("inbuyzone"):
                    ActualCash = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
                    if int(ActualCash) >= cash:
                        FinalCash = int(ActualCash) - cash
                        es.setplayerprop(userid, "CCSPlayer.m_iAccount", FinalCash)
                        Script.tell(userid, "Acheté: %s pour %s$." % (weapon, cash))
                        if realweapon != "elite":
                            dropWeapon(userid, "primary")
                        else:
                            dropWeapon(userid, "secondary")
                        gamethread.delayed(0.10, es.server.insertcmd, ("es_xgive %s weapon_%s" % (userid, realweapon)))
                    else:
                        Script.tell(userid, "Tu n'as pas assez d'argent pour acheter cette arme.")
                else:
                    es.centertell(userid, "Vous n'êtes pas dans une zone d'achat.")
            else:
                es.centertell(userid, "%i secondes se sont écoulées...\nVous ne pouvez plus rien acheter !" % ScriptBuyTime)
        else:
            es.centertell(userid, "Vous êtes mort.")
    else:
        es.centertell(userid, "Vous devez impérativement être Anti-Terroriste pour pouvoir acheter ceci.")

def dropWeapon (userid, weapon):
    if weapon in ("primary", "secondary"):
        pPlayer = playerlib.getPlayer(userid)
        pWeapon = pPlayer.get(weapon)
        if pWeapon:
            es.sexec(userid, "use %s" % pWeapon)
            es.cexec(userid, "drop")
    else:
        Script.echo("ERREUR: L'ame doit etre 'primary' ou 'secondary'")

def setMapLightStyle ():
    es.server.insertcmd("es_xlightstyle %i %s" % (int(MAPLIGHTSTYLE_INDEX), str(MAPLIGHTSTYLE_STRING)))
    if str(SKYBOXNAME) == "boreal": es.server.insertcmd("sv_skyname sky_borealis01")
    elif str(SKYBOXNAME) == "crepuscule": es.server.insertcmd("sv_skyname sky_day03_06")
    elif str(SKYBOXNAME) == "aurore": es.server.insertcmd("sv_skyname sky_day01_08")
    elif str(SKYBOXNAME) == "nuageux": es.server.insertcmd("sv_skyname sky_day01_09")
    if int(REMOVESUN):
        entitySunMap = es.createentitylist("env_sun")
        if entitySunMap:
            for iEntity in entitySunMap:
                es.server.insertcmd("es_xremove %i" % int(iEntity))
                Script.echo("Soleil de la map retire '%i'." % iEntity)

def showPredatorHP ():
    if predatorUserID:
        predatorName = es.getplayername(predatorUserID)
        predatorHP = es.getplayerprop(predatorUserID, "CCSPlayer.baseclass.m_iHealth")
    
    for userids in es.getUseridList():
        if es.getplayerteam(userids) == 2: # Prédateur
            if predatorHP != 0:
                usermsg.hudhint(userids, "HP : %i" % predatorHP)
            else:
                usermsg.hudhint(userids, "Tu es mort.")
        else: # Survivant ou spectateur
            if predatorUserID:
                usermsg.hudhint(userids, "Prédateur :\n %s [%i HP]" % (predatorName, predatorHP))
            else:
                usermsg.hudhint(userids, "Aucun prédateur")

def goDownload ():
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/ct_gign.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/devices.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/devices.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/devices_norm.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/limbs.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/limbs.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/limbs_norm.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/torso.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/torso.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/models/player/ics/predator/torso_norm.vtf"))

    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.dx80.vtx"))
    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.dx90.vtx"))
    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.mdl"))
    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.phy"))
    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.sw.vtx"))
    gamethread.queue(es.stringtable, ('downloadables', "models/player/ics/predator_rawr/t_leet.vvd"))
    
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view1.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view1.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view2.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view2.vtf"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view3.vmt"))
    gamethread.queue(es.stringtable, ('downloadables', "materials/effects/blackpredator_view3.vtf"))
    
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(AMBIANTSOUND1)))
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(PREDWINSOUND1)))
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(CTDEATH1)))
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(CTDEATH2)))
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(CTDEATH3)))
    gamethread.queue(es.stringtable, ('downloadables', "sound/%s" % str(PREDDEATH1)))

def player_activate (event_var):
    userid = int(event_var["userid"])
    Script.printScriptInfos(userid)
    gamethread.delayed(7, Script.tell, (userid, "Vous devez IMPÉRATIVEMENT télécharger le skin de prédateur!"))
    gamethread.delayed(9, Script.tell, (userid, "Pour plus de fun, acceptez les téléchargements de sons dans vos options du jeu :-)"))
    disableAutokick(userid)
    if int(MINDXLEVEL):
        checkDXLevel(userid)
    if str(AMBIANTSOUND1):
        gamethread.delayed(1, startAmbiantSound, (userid))

def allCheckDXLevel ():
    for all in es.getUseridList():
        checkDXLevel(all)

def checkDXLevel (userid):
    es.queryclientvar(userid, "mat_dxlevel")

def es_player_variable (event_var):
    if event_var["status"] == "success":
        if event_var["variable"] == "mat_dxlevel":
            if int(event_var["value"]) < int(MINDXLEVEL):
                es.server.insertcmd("kickid %s mat_dxlevel doit etre au minimum a %i pour pouvoir jouer au BlackPredator." % (event_var["userid"], int(MINDXLEVEL)))
        else:
            Script.echo("Probleme lors de la recuperation de la valeur de 'mat_dxlevel' sur le clientID '%s'." % event_var["userid"])

def player_disconnect (event_var):
    userid = int(event_var["userid"])
    if event_var["userid"] in CTHavePredSpeed:
        gamethread.cancelDelayed("blackpredator_speedct_%s" % event_var["userid"])
        CTHavePredSpeed.remove(event_var["userid"])
    if userid == predatorUserID:
        global predatorUserID
        predatorUserID = 0
    stopAmbiantSound(event_var["userid"])

def player_spawn (event_var):
    global PoweredPredNightVision
    userid = int(event_var["userid"])
    if int(event_var["es_userteam"]) == 2:
        global predatorUserID
        predatorUserID = userid
        if int(es.getplayerprop(predatorUserID, "CCSPlayer.m_bNightVisionOn"))%2 == 1:
            PoweredPredNightVision = True
        else:
            PoweredPredNightVision = False
        giveAvantagesPredator(predatorUserID)
        gamethread.queue(stripPlayer, (predatorUserID))
        if int(PRED_REMOVEHUD) == 1:
            es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.localdata.m_Local.m_iHideHUD", 8)
        elif int(PRED_REMOVEHUD) == 2:
            es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.localdata.m_Local.m_iHideHUD", 1)
        elif int(PRED_REMOVEHUD) == 3:
            es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.localdata.m_Local.m_iHideHUD", 4)
        else:
            es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.localdata.m_Local.m_iHideHUD", 0)

    elif int(event_var["es_userteam"]) == 3:
        giveavantagestueurs(userid)
        Script.tell(userid, "Attention! Le prédateur n'est pas loin! Cachez vous afin de survivre!")
        es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_Local.m_iHideHUD", 0)
        if int(CANUSETERRORISTWEAPONS):
            Script.tell(userid, "Écrivez !buy pour acheter des armes de terroriste.")

        if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
            if int(es.getplayercount(2)) > 0:
                gamethread.delayed (0.33, addPredatorHealthByCT)

def addPredatorHealthByCT ():
    ct = es.getplayercount(3)
    if int(ct) > 1:
        ActualHealth = es.getplayerprop (predatorUserID, "CCSPlayer.baseclass.m_iHealth")
        FinalHealth = ActualHealth + int(HEALTH_ADDCT_T)
        es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.m_iHealth", int(FinalHealth))
    else:
        es.setplayerprop (predatorUserID, "CCSPlayer.baseclass.m_iHealth", int(HEALTH_T_DEF))

def player_blind (event_var):
    global PredIsFlashed

    if int(FLASHVIEW):
        if event_var["es_userteam"] == "2":
            Alpha     = es.getplayerprop (event_var["userid"], "CCSPlayer.m_flFlashMaxAlpha") - 128
            Duration = es.getplayerprop (event_var["userid"], "CCSPlayer.m_flFlashDuration") - 1
            if float(Duration) > 0.64:
                es.server.insertcmd("es_xfire %s !self addoutput \"rendermode 1\"" % event_var["userid"])
                es.server.insertcmd("es_xfire %s !self alpha %i" % (event_var["userid"], int(Alpha)))
                if PredIsFlashed:
                    gamethread.cancelDelayed("blackpredator_visiblepredator")
                else:
                    PredIsFlashed = True
                gamethread.delayedname (float(Duration), "blackpredator_visiblepredator", stopPrdatorVisible, event_var["userid"])

        es.setplayerprop(event_var["userid"], "CCSPlayer.m_flFlashMaxAlpha", 0)
        es.setplayerprop(event_var["userid"], "CCSPlayer.m_flFlashDuration", 0)

def stopPrdatorVisible (userid):
    global PredIsFlashed

    es.server.insertcmd("es_xfire %s !self alpha %i" % (userid, int(TRANSPARENCE_T)))
    PredIsFlashed = False

def getRandomPlayer (team):
    UseridList = playerlib.getUseridList(team)
    if UseridList:
        OneUserid = random.choice(UseridList)
        if OneUserid:
            return OneUserid

def getNewRandomUserID ():
    return int(random.choice(es.getUseridList()))

def killPlayer (userid):
    es.server.insertcmd("es_xfire %s !self sethealth 0" % userid)

def godPlayer (userid):
    if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
        es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 0)

def hideCutAndHand (userid):
    if int(HIDE_CUT_AND_HAND):
        es.setplayerprop (userid, "CBasePlayer.m_iFOV", 91)

def player_death (event_var):
    global StopPredOverlay

    if event_var["es_userteam"] == "2" and event_var["es_attackerteam"] == "3":
        if int(PREDATORCHOICERANDOM) == 0:
            global predatorUserID
            StopPredOverlay = True
            spe.switchTeam(int(event_var["userid"]), 3)
            es.delayed(float(SoonPredSwitch), spe.switchTeam, (int(event_var["attacker"]), 2))
            godPlayer(event_var["attacker"])
            Script.tell(event_var["attacker"], "Tu es maintenant le prédateur.")
            predatorUserID = int(event_var["userid"])
        elif int(PREDATORCHOICERANDOM) == 2:
            predChangeRandom()
        elif int(PREDATORCHOICERANDOM) == 4:
            predChangeBestDommages()

        if str(PREDDEATH1):
            for i in es.getUseridList():
                es.playsound(i, PREDDEATH1, 1.0)

    elif event_var["es_userteam"] == "3" and event_var["es_attackerteam"] == "2":
        es.setplayerprop(event_var["attacker"], "CCSPlayer.m_iAccount", 0)
        if int(PRED_KILLBONUS):
            hp = int(event_var["es_attackerhealth"]) + int(PRED_BONUSVIE)
            es.setplayerprop (event_var["attacker"], "CCSPlayer.baseclass.m_iHealth", int(hp))
            Script.tell(event_var["attacker"], "BONUS! Tu as gagné %i HP pour avoir tué!" % PRED_BONUSVIE)
            if str(CTDEATH1) and str(CTDEATH2) and str(CTDEATH3):
                rand = random.randint(1, 3)
                if rand == 1: es.emitsound ("player", event_var["userid"], CTDEATH1, 1.0, 1.0)
                elif rand == 2: es.emitsound ("player", event_var["userid"], CTDEATH2, 1.0, 1.0)
                elif rand == 3: es.emitsound ("player", event_var["userid"], CTDEATH3, 1.0, 1.0)
        if event_var["es_username"] in DommagesOnPredByCT:
            Script.tell(event_var["userid"], "Tu as fait %i dommages au prédateur ce round-ci." % DommagesOnPredByCT[event_var["es_username"]])
        else:
            Script.tell(event_var["userid"], "Tu n'as fait aucuns dommages au prédateur ce round-ci.")

    if event_var["userid"] in CTHavePredSpeed:
        gamethread.cancelDelayed("blackpredator_speedct_%s" % event_var["userid"])
        CTHavePredSpeed.remove(event_var["userid"])
    
    if int(event_var["es_userteam"]) == 2:
        if str(SCREENOVERLAY_PRED) != "0":
            es.server.insertcmd("es_xcexec %s r_screenoverlay 0" % event_var["userid"])
    
    if int(MINDXLEVEL):
        checkDXLevel(event_var["userid"])

def player_hurt (event_var):
    global DommagesOnPred

    if event_var["es_userteam"] == "2" and event_var["es_attackerteam"] == "3":
        es.centertell (event_var["attacker"], "-%s HP" % event_var["dmg_health"])
        DommagesOnPred += int(event_var["dmg_health"])
        if event_var["es_attackername"] not in DommagesOnPredByCT:
            DommagesOnPredByCT[event_var["es_attackername"]] = int(event_var["dmg_health"])
        else:
            DommagesOnPredByCT[event_var["es_attackername"]] += int(event_var["dmg_health"])

        if int(SPEEDCUTCT):
            if event_var["weapon"] == "knife":
                if event_var["attacker"] not in CTHavePredSpeed:
                    CTHavePredSpeed.append(event_var["attacker"])
                    es.setplayerprop(event_var["attacker"], "CCSPlayer.baseclass.localdata.m_flLaggedMovementValue", float(VITESSE_T))
                    gamethread.delayedname(int(SPEEDCUTCT_TIME), "blackpredator_speedct_%s" % event_var["attacker"], stopspeedct, event_var["attacker"])
                    Script.tell(event_var["attacker"], "BONUS! Tu vas plus vite pendant %i secondes pour avoir cutté le prédateur!" % int(SPEEDCUTCT_TIME))

    if event_var["es_userteam"] == "3" and event_var["es_attackerteam"] == "2":
        if int(SCREENBLOOD):
            giveScreenBlood(event_var["userid"])

def giveScreenBlood (userid):
    usermsg.fade(userid, 1, 200, 10, 255, 10, 10, 133)
    usermsg.shake(userid, 10, 1.5)

def stopspeedct (userid):
    es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_flLaggedMovementValue", 1)
    Script.tell(userid, "BONUS! Ton bonus de vitesse est terminé.")
    CTHavePredSpeed.remove(userid)

def round_start (event_var):
    global DommagesOnPred
    global StopPredOverlay
    
    StopPredOverlay = False

    es.forcevalue("sv_hudhint_sound", 0)
    es.forcevalue("mp_autoteambalance", 0)
    es.forcevalue("mp_limitteams", 0)
    es.forcevalue("sv_rollangle", int(ROLLANGE))

    deleteMapObjectives()
    DommagesOnPred = 0
    DommagesOnPredByCT.clear()
    canBuyWeaponsOfTerrorists("yes")
   
    execBPCvars()

    for clients in es.getUseridList():
        if str(AMBIANTSOUND1):
            gamethread.delayed(1, startAmbiantSound, (clients))

def execBPCvars ():
    CommandList = []
    for CVar in BPCVarList:
        es.server.insertcmd("es_xforcevalue " + CVar + " " + BPCVarList[CVar])
        CommandList.append(CVar)
    
    Script.echo("Commandes executees: %s" % CommandList)

def deleteMapObjectives ():
    for eLIndex in EntityRemoveList:
        entityList = es.createentitylist(eLIndex)
        if entityList:
            for iEntity in entityList:
                es.server.insertcmd("es_xremove %i" % int(iEntity))
                Script.echo("Entite retiree de la map '%i': %s" % (iEntity, entityList[iEntity]["classname"]))

def round_freeze_end (event_var):
    global ScriptBuyTime

    if int(PRED_FREEZETIME):
        if predatorUserID:
            es.setplayerprop(predatorUserID, "CCSPlayer.m_iPlayerState", 1)
            Script.tell(predatorUserID, "Tu pourras démarrer dans %i secondes." % int(PRED_FREEZETIME))
            gamethread.delayed(int(PRED_FREEZETIME), es.setplayerprop, (predatorUserID, "CCSPlayer.m_iPlayerState", 0))
            gamethread.delayed(int(PRED_FREEZETIME), Script.tell, (predatorUserID, "GO! Tu es prédateur, tues les tous!"))

    ScriptBuyTime = float(es.server_var["mp_buytime"]) / 0.01667
    ScriptBuyTime = round(ScriptBuyTime, 0)

    gamethread.delayedname (ScriptBuyTime, "blackpredator_scriptbuytime", canBuyWeaponsOfTerrorists, "no")

def getBestDommagesCT ():
    bestPlayer = 0
    bestDommages = 0
    for i in DommagesOnPredByCT:
        if DommagesOnPredByCT[i] > bestDommages:
            bestPlayer = i
            bestDommages = DommagesOnPredByCT[i]
    return [bestPlayer, bestDommages]

def player_team (event_var):
    userid = int(event_var["userid"])
    if userid == predatorUserID:
        global predatorUserID
        predatorUserID = 0
    if int(event_var["oldteam"]) == 2:
        if str(SCREENOVERLAY_PRED) != "0":
            es.server.insertcmd("es_xcexec %s r_screenoverlay 0" % event_var["userid"])

def round_end (event_var):
    for i in CTHavePredSpeed:
        stopspeedct(i)

    if DommagesOnPred != 0:
        returned = getBestDommagesCT()
        Script.msg("%s à fait le plus de dégats sur le prédateur ce round ci avec %i dommages." % (returned[0], returned[1]))
        Script.msg ("Total des dommages sur le prédateur : %i dommages." % DommagesOnPred)
    else:
        Script.msg ("Aucuns dégats n'ont été infligés ce round ci sur le prédateur.")
    
    for a in es.getUseridList():
        if es.getplayerteam(a) == 3:
            if str(SCREENOVERLAY_PRED) != "0":
                es.server.insertcmd("es_xcexec %s r_screenoverlay 0" % a)

        if event_var["winner"] == "2":
            if str(PREDWINSOUND1):
                es.playsound (a, PREDWINSOUND1, 1.0)

        if not es.getplayerprop(a, "CCSPlayer.baseclass.pl.deadflag"):
            godPlayer(a)
            if int(es.getplayerteam(a)) == 3:
                if es.getplayername(a) in DommagesOnPredByCT:
                    Script.tell(a, "Tu as fait %i dommages au prédateur ce round-ci." % DommagesOnPredByCT[es.getplayername(a)])
                else:
                    Script.tell(a, "Tu n'as fait aucuns dommages au prédateur ce round-ci.")

    if int(PREDATORCHOICERANDOM) == 1:
        predChangeRandom()
    
    elif int(PREDATORCHOICERANDOM) == 3:
        predChangeBestDommages()

    gamethread.cancelDelayed("blackpredator_scriptbuytime")

def predChangeBestDommages ():
    global StopPredOverlay
    global predatorUserID
    StopPredOverlay = True
    best = getBestDommagesCT()
    bestUserID = es.getuserid(best[0])
    spe.switchTeam (predatorUserID, 3)
    if es.getplayerteam(bestUserID) not in (0, 1):
        gamethread.delayed(int(SoonPredSwitch), spe.switchTeam, (int(bestUserID), 2))
        godPlayer(int(bestUserID))
        Script.tell(bestUserID, "Tu es maintenant le prédateur.")
        predatorUserID = bestUserID
    else:
        Script.msg("Le CT qui devrait normalement être prédateur n'est pas dans une équipe. CT choisit aléatoirement.")
        randomCTUserid = getRandomPlayer("#ct")
        if randomCTUserid:
            gamethread.delayed(int(SoonPredSwitch), spe.switchTeam, (int(randomCTUserid), 2))
            godPlayer(int(randomCTUserid))
            Script.tell(randomCTUserid, "Tu es maintenant le prédateur.")
            predatorUserID = randomCTUserid
        else:
            Script.msg("Aucun prédateur trouvé.. La place est libre")
            predatorUserID = 0

def predChangeRandom ():
    global StopPredOverlay
    global predatorUserID
    StopPredOverlay = True
    pCT = getRandomPlayer("#ct")
    if pCT:
        predatorUserID = pCT
        godPlayer(pCT)
        gamethread.delayed(int(SoonPredSwitch), spe.switchTeam, (int(pCT), 2))
        Script.tell(pCT, "Tu es maintenant le prédateur.")
        spe.switchTeam (int(predatorUserID), 3)
    else:
        Script.msg("Aucun prédateur trouvé.. La place est libre")
        predatorUserID = 0

def item_pickup (event_var):
    if int(event_var["es_userteam"]) == 2:
        if event_var["item"] not in StripedItems:
            removePickupItem(event_var["userid"], event_var["item"])

def checkIgnoreWeapon (item):
    for ignoredWeapon in IgnoredWeaponStrip:
        if ignoredWeapon.split("_")[1] == item:
            return True
    return False

def player_jump (event_var):
    if int(event_var["es_userteam"]) == 2:
        if float(GRAVITY_T) != 1.00:
            es.server.insertcmd("es_xfire %s !self addoutput \"gravity %f\"" % (event_var["userid"], GRAVITY_T))
    elif int(event_var["es_userteam"]) == 3:
        es.server.insertcmd("es_xfire %s !self addoutput \"gravity 1.00\"" % event_var["userid"])

def es_map_start (event_var):
    global BPCVarList
    global predatorUserID
    predatorUserID = 0
    Script.execConfig()
    BPCVarList = {}
    gamethread.delayed(0.25, es.mexec, ("../addons/eventscripts/blackpredator/blackpredator_config.cfg"))
    goDownload()
    setMapLightStyle()

def giveAvantagesPredator (userid):
    plid = playerlib.getPlayer(userid)

    if float(VITESSE_T) != 1.00:
        es.setplayerprop (userid, "CCSPlayer.baseclass.localdata.m_flLaggedMovementValue", float(VITESSE_T))

    if int(TRANSPARENCE_T) != 255:
        es.server.insertcmd("es_xfire %s !self addoutput \"rendermode 1\"" % userid)
        es.server.insertcmd("es_xfire %s !self alpha %i" % (userid, int(TRANSPARENCE_T)))

    plid.set("model", "player/ics/predator_rawr/t_leet")
    es.setplayerprop (userid, "CCSPlayer.m_iAccount", 0)
    es.setplayerprop (userid, "CCSPlayer.baseclass.localdata.m_Local.m_bWearingSuit", 1)
    es.setplayerprop (userid, "CCSPlayer.m_bHasHelmet", 1)
    es.setplayerprop (userid, "CCSPlayer.m_ArmorValue", 100)
    
    plid.set("color", [25, 25, 25, int(TRANSPARENCE_T)])
    
    if int(NOCTURNE_GIVE_T):
        es.server.insertcmd("es_xgive %s item_nvgs" % userid)

def giveavantagestueurs (userid):
    if int(CASH_CT):
        es.setplayerprop (userid, "CCSPlayer.m_iAccount", int(CASH_CT))

    es.server.insertcmd("es_xfire %s !self addoutput \"rendermode 1\"" % userid)
    es.server.insertcmd("es_xfire %s !self alpha 255" % userid)
    
    plid = playerlib.getPlayer(userid)
    plid.set("color", [255, 255, 255, 255])

    es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_flLaggedMovementValue", 1)

def startAmbiantSound (userid):
    if not es.isbot(userid):
        stopAmbiantSound(str(userid))
        gamethread.delayed(0.5, es.playsound, (str(userid), str(AMBIANTSOUND1), 1.0))
        gamethread.delayedname(int(AMBIANTSOUNDTIME), "blackpredator_ambiantsound_%s" % str(userid), startAmbiantSound, str(userid))
        StartedPlayersAmbiantSound.append(str(userid))

def stopAmbiantSound (userid):
    if not es.isbot(userid):
        if str(userid) in StartedPlayersAmbiantSound:
            gamethread.cancelDelayed("blackpredator_ambiantsound_%s" % str(userid))
            es.stopsound(str(userid), str(AMBIANTSOUND1))
            StartedPlayersAmbiantSound.remove(str(userid))

def parseclientcmd (userid, command):
    if command[0].lower() == "jointeam":
        t     = es.getplayercount(2)
        if int(command[1]) == 2:
            if int(t) >= 1:
                es.centertell (userid, "Il y a trop de predateurs.")
                return False
            else:
                Script.tell(userid, "Tu es maintenant le prédateur.")
                return True

        elif int(command[1]) == 0:
            if int(t) >= 1:
                es.changeteam(userid, 3)
                return False
            else:
                Script.tell(userid, "Tu es maintenant le prédateur.")
                return True
    
    elif command[0].lower() == "kill" or command[0].lower() == "explode":
        if int(es.getplayerteam(userid)) == 2:
            Script.tell (userid, "Le suicide, c'est mal!")
            return False
        else:
            killPlayer(userid)
            return True
    return True

def stripPlayer (userid):
    es.server.insertcmd("es_xfire %s player_weaponstrip kill" % userid)
    es.server.insertcmd("es_xgive %s player_weaponstrip" % userid)
    es.server.insertcmd("es_xfire %s player_weaponstrip strip" % userid)
    for item in StripedItems:
        if item not in ("nvgs", "defuser"):
            gamethread.delayed(0.10, es.server.insertcmd, ("es_xgive %s weapon_%s" % (userid, item)))
            if item == "knife":
                gamethread.delayed(0.20, es.server.insertcmd, ("es_xfire %s weapon_knife addoutput \"rendermode 1\"" % userid))
                gamethread.delayed(0.20, es.server.insertcmd, ("es_xfire %s weapon_knife alpha %i" % (userid, int(TRANSPARENCE_T))))
                gamethread.delayed(0.20, es.server.insertcmd, ("es_xfire %s weapon_knife DisableShadow" % userid))
        else:
            if int(NOCTURNE_GIVE_T):
                gamethread.delayed(0.10, es.server.insertcmd, ("es_xgive %s item_%s" % (userid, item)))
                if item == "nvgs":
                    if bool(PoweredPredNightVision):
                        gamethread.delayed(0.25, es.setplayerprop, (userid, "CCSPlayer.m_bNightVisionOn", 1))

def removePickupItem (userid, item):
    handle = es.getplayerhandle(userid)
    for index in es.getEntityIndexes("weapon_%s" % item):
        if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == handle:
            if es.getplayerprop(userid, "CBaseCombatCharacter.m_hActiveWeapon") == es.gethandlefromindex(index):
                es.cexec(userid, "lastinv")
            spe.dropWeapon(userid, "weapon_%s" % item, False)
            gamethread.delayed(0.20, spe.call, ("Remove", spe.getEntityOfIndex(index)))
            break

def disableAutokick(userid):
    es.server.mp_disable_autokick(userid)